/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the Role type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Role{}

// Role struct for Role
type Role struct {
	Name            string         `json:"name"`
	DisplayName     string         `json:"displayName"`
	Description     string         `json:"description"`
	ApplicationId   *string        `json:"applicationId,omitempty"`
	Required        *bool          `json:"required,omitempty"`
	MinimumLoaId    NullableString `json:"minimumLoaId,omitempty"`
	Multifactor     *bool          `json:"multifactor,omitempty"`
	ApplyToAllUsers *bool          `json:"applyToAllUsers,omitempty"`
	Id              NullableString `json:"id,omitempty"`
	CreationTime    *time.Time     `json:"creationTime,omitempty"`
}

type _Role Role

// NewRole instantiates a new Role object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRole(name string, displayName string, description string) *Role {
	this := Role{}
	this.Name = name
	this.DisplayName = displayName
	this.Description = description
	return &this
}

// NewRoleWithDefaults instantiates a new Role object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRoleWithDefaults() *Role {
	this := Role{}
	return &this
}

// GetName returns the Name field value
func (o *Role) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Role) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Role) SetName(v string) {
	o.Name = v
}

// GetDisplayName returns the DisplayName field value
func (o *Role) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *Role) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *Role) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetDescription returns the Description field value
func (o *Role) GetDescription() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Description
}

// GetDescriptionOk returns a tuple with the Description field value
// and a boolean to check if the value has been set.
func (o *Role) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Description, true
}

// SetDescription sets field value
func (o *Role) SetDescription(v string) {
	o.Description = v
}

// GetApplicationId returns the ApplicationId field value if set, zero value otherwise.
func (o *Role) GetApplicationId() string {
	if o == nil || IsNil(o.ApplicationId) {
		var ret string
		return ret
	}
	return *o.ApplicationId
}

// GetApplicationIdOk returns a tuple with the ApplicationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Role) GetApplicationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ApplicationId) {
		return nil, false
	}
	return o.ApplicationId, true
}

// HasApplicationId returns a boolean if a field has been set.
func (o *Role) HasApplicationId() bool {
	if o != nil && !IsNil(o.ApplicationId) {
		return true
	}

	return false
}

// SetApplicationId gets a reference to the given string and assigns it to the ApplicationId field.
func (o *Role) SetApplicationId(v string) {
	o.ApplicationId = &v
}

// GetRequired returns the Required field value if set, zero value otherwise.
func (o *Role) GetRequired() bool {
	if o == nil || IsNil(o.Required) {
		var ret bool
		return ret
	}
	return *o.Required
}

// GetRequiredOk returns a tuple with the Required field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Role) GetRequiredOk() (*bool, bool) {
	if o == nil || IsNil(o.Required) {
		return nil, false
	}
	return o.Required, true
}

// HasRequired returns a boolean if a field has been set.
func (o *Role) HasRequired() bool {
	if o != nil && !IsNil(o.Required) {
		return true
	}

	return false
}

// SetRequired gets a reference to the given bool and assigns it to the Required field.
func (o *Role) SetRequired(v bool) {
	o.Required = &v
}

// GetMinimumLoaId returns the MinimumLoaId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Role) GetMinimumLoaId() string {
	if o == nil || IsNil(o.MinimumLoaId.Get()) {
		var ret string
		return ret
	}
	return *o.MinimumLoaId.Get()
}

// GetMinimumLoaIdOk returns a tuple with the MinimumLoaId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Role) GetMinimumLoaIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.MinimumLoaId.Get(), o.MinimumLoaId.IsSet()
}

// HasMinimumLoaId returns a boolean if a field has been set.
func (o *Role) HasMinimumLoaId() bool {
	if o != nil && o.MinimumLoaId.IsSet() {
		return true
	}

	return false
}

// SetMinimumLoaId gets a reference to the given NullableString and assigns it to the MinimumLoaId field.
func (o *Role) SetMinimumLoaId(v string) {
	o.MinimumLoaId.Set(&v)
}

// SetMinimumLoaIdNil sets the value for MinimumLoaId to be an explicit nil
func (o *Role) SetMinimumLoaIdNil() {
	o.MinimumLoaId.Set(nil)
}

// UnsetMinimumLoaId ensures that no value is present for MinimumLoaId, not even an explicit nil
func (o *Role) UnsetMinimumLoaId() {
	o.MinimumLoaId.Unset()
}

// GetMultifactor returns the Multifactor field value if set, zero value otherwise.
func (o *Role) GetMultifactor() bool {
	if o == nil || IsNil(o.Multifactor) {
		var ret bool
		return ret
	}
	return *o.Multifactor
}

// GetMultifactorOk returns a tuple with the Multifactor field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Role) GetMultifactorOk() (*bool, bool) {
	if o == nil || IsNil(o.Multifactor) {
		return nil, false
	}
	return o.Multifactor, true
}

// HasMultifactor returns a boolean if a field has been set.
func (o *Role) HasMultifactor() bool {
	if o != nil && !IsNil(o.Multifactor) {
		return true
	}

	return false
}

// SetMultifactor gets a reference to the given bool and assigns it to the Multifactor field.
func (o *Role) SetMultifactor(v bool) {
	o.Multifactor = &v
}

// GetApplyToAllUsers returns the ApplyToAllUsers field value if set, zero value otherwise.
func (o *Role) GetApplyToAllUsers() bool {
	if o == nil || IsNil(o.ApplyToAllUsers) {
		var ret bool
		return ret
	}
	return *o.ApplyToAllUsers
}

// GetApplyToAllUsersOk returns a tuple with the ApplyToAllUsers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Role) GetApplyToAllUsersOk() (*bool, bool) {
	if o == nil || IsNil(o.ApplyToAllUsers) {
		return nil, false
	}
	return o.ApplyToAllUsers, true
}

// HasApplyToAllUsers returns a boolean if a field has been set.
func (o *Role) HasApplyToAllUsers() bool {
	if o != nil && !IsNil(o.ApplyToAllUsers) {
		return true
	}

	return false
}

// SetApplyToAllUsers gets a reference to the given bool and assigns it to the ApplyToAllUsers field.
func (o *Role) SetApplyToAllUsers(v bool) {
	o.ApplyToAllUsers = &v
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Role) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Role) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *Role) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *Role) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *Role) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *Role) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *Role) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Role) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *Role) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *Role) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o Role) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Role) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["displayName"] = o.DisplayName
	toSerialize["description"] = o.Description
	if !IsNil(o.ApplicationId) {
		toSerialize["applicationId"] = o.ApplicationId
	}
	if !IsNil(o.Required) {
		toSerialize["required"] = o.Required
	}
	if o.MinimumLoaId.IsSet() {
		toSerialize["minimumLoaId"] = o.MinimumLoaId.Get()
	}
	if !IsNil(o.Multifactor) {
		toSerialize["multifactor"] = o.Multifactor
	}
	if !IsNil(o.ApplyToAllUsers) {
		toSerialize["applyToAllUsers"] = o.ApplyToAllUsers
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *Role) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"name",
		"displayName",
		"description",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varRole := _Role{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varRole)

	if err != nil {
		return err
	}

	*o = Role(varRole)

	return err
}

type NullableRole struct {
	value *Role
	isSet bool
}

func (v NullableRole) Get() *Role {
	return v.value
}

func (v *NullableRole) Set(val *Role) {
	v.value = val
	v.isSet = true
}

func (v NullableRole) IsSet() bool {
	return v.isSet
}

func (v *NullableRole) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRole(val *Role) *NullableRole {
	return &NullableRole{value: val, isSet: true}
}

func (v NullableRole) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRole) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
